Subject: Re: bug#27041: MacOS 10.6: fix NS build

From: Alan Third <[email-masked]>
Date: Wed, 24 May 2017 20:03:34 +0100

On Wed, May 24, 2017 at 08:13:21PM +0200, Charles A. Roelli wrote:
> Thanks for your help.
> 
> I changed the conditional to this:
> 
> 
> #if defined(NS_IMPL_GNUSTEP) || MAC_OS_X_VERSION_MAX_ALLOWED <
> MAC_OS_X_VERSION_10_7
> typedef id instancetype;
> typedef NSUInteger NSWindowStyleMask;
> #endif
> 
> 
> And it compiles fine without my previous changes.  Can you verify that this
> still builds with GNUstep?  If not, we can leave the 'int' instead of the
> 'NSUInteger'.

It works fine on GNUstep too, so I’ve pushed the change.

FWIW, that instancetype type appears to be a built‐in and we should
probably be doing some sort of check whether the compiler supports it
natively or not. I don’t know how to go about doing that.

> > > I also see this warning when compiling macfont.m:
> > > 
> > > macfont.m: In function ‘mac_font_shape_1’:
> > > macfont.m:416: warning: ‘NSLayoutManager’ may not respond to
> > > ‘-getGlyphsInRange:glyphs:properties:characterIndexes:bidiLevels:’
> > > macfont.m:416: warning: (Messages without a matching method signature
> > > macfont.m:416: warning: will be assumed to return ‘id’ and accept
> > > macfont.m:416: warning: ‘...’ as arguments.)
> > > 
> > > (some new arguments were added in the recent changes).  But this doesn't
> > > seem to affect functionality so I've left that change as is.

This warning doesn’t make much sense to me. I’ve looked up the
documentation and the new method being used has allegedly been
available since macOS 10.5.

https://developer.apple.com/reference/appkit/nslayoutmanager/1403104-getglyphsinrange

I guess if it’s working we can just ignore it.

-- 
Alan Third